#ifndef SBCLIB_RND_sjbBuild2DMipmaps
#include <rnd/Maxi.c>
#ifndef SBCLIB_GFX_GLES_RPI
#include <GL/gl.h>
#endif

int intel_hd_graphics_cludge=0;
// Main PC doesn't care and laptop prefers this is 1 (0 gives block fonts)
// Maybe some clues here?  https://www.khronos.org/opengl/wiki/Common_Mistakes#Texture_upload_and_pixel_reads
const GLenum sjbBuild2DMipmaps_fmts[5]={0,GL_LUMINANCE,GL_LUMINANCE_ALPHA,GL_RGB,GL_RGBA};

void glTexImage2D_sjb_fixed(const GLenum target,const GLint level,
	const GLint cs,const GLsizei xs,const GLsizei ys,const GLenum type,const GLvoid *d)
{
	GLenum cf=sjbBuild2DMipmaps_fmts[cs];
	GLenum e0=glGetError(),e1;
	glTexImage2D(target,level,intel_hd_graphics_cludge?cs:cf,xs,ys,0,cf,GL_UNSIGNED_BYTE,d);
	if (0)
	{
		e1=glGetError();
		FILE *out=fopen("glTexImage2D_sjb_fixed.log","at");
		fprintf(out,"intel_hd_graphics_cludge=%d e0=%d e1=%d\n",intel_hd_graphics_cludge,e0,e1);
		if (e0==GL_NO_ERROR && e1!=GL_NO_ERROR)
		{
			intel_hd_graphics_cludge^=1;
			fprintf(out,"Trying again toggled...\n");
			glTexImage2D(target,level,intel_hd_graphics_cludge?cs:cf,xs,ys,0,cf,GL_UNSIGNED_BYTE,d);
			GLenum e2=glGetError();
			fprintf(out,"intel_hd_graphics_cludge=%d e1=%d e2=%d\n",intel_hd_graphics_cludge,e1,e2);
			intel_hd_graphics_cludge^=1;
		}
		fclose(out);
	}
}

void sjbBuild2DMipmaps_upper(const GLenum target,const int cs,const GLenum cf,int xs,int ys,unsigned char *d)
{
	int n,x,y,c,op=(xs*cs+3)/4*4,p; unsigned char *e,*f;
	for (n=1;xs>1 || ys>1;n++)
	{
		xs=Maxi(1,xs/2); ys=Maxi(1,ys/2);
		p=(xs*cs+3)/4*4;
		for (y=0;y<ys;y++) for (x=0;x<xs;x++)
		{
			e=d+x*cs+y*p;
			f=d+x*2*cs+y*2*op;
			for (c=cs-1;c>=0;c--,e++,f++) e[0]=((int)f[0]+(int)f[cs]+(int)f[op]+(int)f[cs+op]+2)/4;
		}
		glTexImage2D_sjb_fixed(target,n,cs,xs,ys,GL_UNSIGNED_BYTE,d);
		op=p;
	}
}

void sjbBuild2DMipmaps_inner(const GLenum target,const int cs,int xs,int ys,unsigned char *d)
{
	GLenum cf=sjbBuild2DMipmaps_fmts[cs];
	glTexImage2D_sjb_fixed(target,0,cs,xs,ys,GL_UNSIGNED_BYTE,d);
	void glGenerateMipmap(GLenum);
	glGenerateMipmap(target);
	//sjbBuild2DMipmaps_upper(target,cs,cf,xs,ys,d);
}

#define sjbBuild2DMipmaps(cs,xs,ys,d) sjbBuild2DMipmaps_inner(GL_TEXTURE_2D,cs,xs,ys,d);

#ifndef SBCLIB_GFX_GLES_RPI
void sjbBuildCubeMipmaps(const int cs,const int sz,
	unsigned char *px,unsigned char *nx,
	unsigned char *py,unsigned char *ny,
	unsigned char *pz,unsigned char *nz)
{
	sjbBuild2DMipmaps_inner(GL_TEXTURE_CUBE_MAP_POSITIVE_X,cs,sz,sz,px);
	sjbBuild2DMipmaps_inner(GL_TEXTURE_CUBE_MAP_NEGATIVE_X,cs,sz,sz,nx);
	sjbBuild2DMipmaps_inner(GL_TEXTURE_CUBE_MAP_POSITIVE_Y,cs,sz,sz,py);
	sjbBuild2DMipmaps_inner(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,cs,sz,sz,ny);
	sjbBuild2DMipmaps_inner(GL_TEXTURE_CUBE_MAP_POSITIVE_Z,cs,sz,sz,pz);
	sjbBuild2DMipmaps_inner(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,cs,sz,sz,nz);
}

void sjbBuild2DMipmaps_existing(void)
{ // Uses level 0 of the existing texture
	int xs,ys,cs,cf;
	glGetTexLevelParameteriv(GL_TEXTURE_2D,0,GL_TEXTURE_WIDTH,&xs);
	glGetTexLevelParameteriv(GL_TEXTURE_2D,0,GL_TEXTURE_HEIGHT,&ys);
	glGetTexLevelParameteriv(GL_TEXTURE_2D,0,GL_TEXTURE_INTERNAL_FORMAT,&cf);
	for (cs=1;cs<=4;cs++) if ((int)sjbBuild2DMipmaps_fmts[cs]==cf) break; if (cs>4) {if (cf<=4) cs=cf; else cs=3;}
	cf=sjbBuild2DMipmaps_fmts[cs];
	unsigned char *d=(unsigned char *)malloc((xs*cs+3)/4*4*ys);
	glGetTexImage(GL_TEXTURE_2D,0,cf,GL_UNSIGNED_BYTE,d);
	sjbBuild2DMipmaps_upper(GL_TEXTURE_2D,cs,cf,xs,ys,d);
	free(d);
}
#endif

#define SBCLIB_RND_sjbBuild2DMipmaps
#endif
