// The beginnings of a compression library (Stephen Brooks 2001)

void rle(unsigned char **a,unsigned *length)
{ // Escaped RLE (3-byte symbols esc-char-runs)
	int n,i,e,c,r,f[256],x;
	unsigned char *b=(unsigned char *)malloc(*length*3+1),*ret;
	for (n=0;n<256;n++) f[n]=0;
	for (n=0;n<*length;n++) f[(*a)[n]]++;
	e=0;
	for (n=1;n<256;n++) if (f[n]<f[e]) e=n;
	b[0]=e; i=1; c=-1; r=0;
	for (n=0;n<=*length;n++)
	{
		x=(n<*length)?(*a)[n]:-1;
		if (x!=c)
		{
			if (c>=0)
			{
				if (r==1 && c!=e) b[i++]=c;
				else if (r==2 && c!=e) {b[i++]=c; b[i++]=c;}
				else if (r==3 && c!=e) {b[i++]=c; b[i++]=c; b[i++]=c;}
				else {b[i++]=e; b[i++]=c; b[i++]=r;}
			}
			c=x; r=1;
		}
		else if (r<255) r++;
		else
		{
			b[i++]=e; b[i++]=c; b[i++]=r;
			c=x; r=1;
		}
	}
	free(*a);
	ret=(unsigned char *)malloc(i); memcpy(ret,b,i); free(b);
	*a=ret; *length=i;
}

void unrle(unsigned char **a,unsigned *length)
{
	int n,i,j,e=**a;
	unsigned char *b;
	i=0;
	for (n=1;n<*length;n++)
	{
		if ((*a)[n]==e) {i+=(*a)[n+2]; n+=2;}
		else i++;
	}
	b=(unsigned char *)malloc(i); i=0;
	for (n=1;n<*length;n++)
	{
		if ((*a)[n]==e) {for (j=0;j<(*a)[n+2];j++) b[i++]=(*a)[n+1]; n+=2;}
		else b[i++]=(*a)[n];
	}
	free(*a);
	*a=b; *length=i;
}

// Next: generalised Huffman (and arithmetic?) algorithms acting on streams of integers (can re-implement RLE using this!)
// + Could consider segmental adaptive versions as well as [tree][data]

// After that: either LZ77-type, dictionary or Markov-chain-based prediction algorithm, can be stacked on previous
